Imports System.Runtime.Serialization

<Serializable()> _
Public Class Person
    Public Name As String
    Public Street As String
    Public City As String
    Public State As String
    Public Zip As String

    ' Make a new Person from Name, Street, 
    ' City, State, and Zip.
    Public Sub New(ByVal new_name As String, ByVal new_street As String, ByVal new_city As String, ByVal new_state As String, ByVal new_zip As String)
        Name = new_name
        Street = new_street
        City = new_city
        State = new_state
        Zip = new_zip
    End Sub

    ' Make a new Person from Name, Street, 
    ' City, State, and Zip all in one string.
    Public Sub New(ByVal txt As String)
        txt = txt.Replace(vbCrLf, ";")
        Dim lines() As String = txt.Split(";"c)
        Name = lines(0)
        Street = lines(1)
        Dim city_state_zip() As String = lines(2).Split(" "c)
        City = city_state_zip(0)
        State = city_state_zip(1)
        Zip = city_state_zip(2)
    End Sub
End Class

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lstPersonInfo As System.Windows.Forms.ListBox
    Friend WithEvents lblPerson2 As System.Windows.Forms.Label
    Friend WithEvents lblPerson1 As System.Windows.Forms.Label
    Friend WithEvents lblPerson0 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lstPersonInfo = New System.Windows.Forms.ListBox
        Me.lblPerson2 = New System.Windows.Forms.Label
        Me.lblPerson1 = New System.Windows.Forms.Label
        Me.lblPerson0 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'lstPersonInfo
        '
        Me.lstPersonInfo.AllowDrop = True
        Me.lstPersonInfo.Items.AddRange(New Object() {""})
        Me.lstPersonInfo.Location = New System.Drawing.Point(184, 72)
        Me.lstPersonInfo.Name = "lstPersonInfo"
        Me.lstPersonInfo.Size = New System.Drawing.Size(144, 56)
        Me.lstPersonInfo.TabIndex = 7
        '
        'lblPerson2
        '
        Me.lblPerson2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblPerson2.Location = New System.Drawing.Point(8, 136)
        Me.lblPerson2.Name = "lblPerson2"
        Me.lblPerson2.Size = New System.Drawing.Size(144, 56)
        Me.lblPerson2.TabIndex = 6
        '
        'lblPerson1
        '
        Me.lblPerson1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblPerson1.Location = New System.Drawing.Point(8, 72)
        Me.lblPerson1.Name = "lblPerson1"
        Me.lblPerson1.Size = New System.Drawing.Size(144, 56)
        Me.lblPerson1.TabIndex = 5
        '
        'lblPerson0
        '
        Me.lblPerson0.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblPerson0.Location = New System.Drawing.Point(8, 8)
        Me.lblPerson0.Name = "lblPerson0"
        Me.lblPerson0.Size = New System.Drawing.Size(144, 56)
        Me.lblPerson0.TabIndex = 4
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(336, 197)
        Me.Controls.Add(Me.lstPersonInfo)
        Me.Controls.Add(Me.lblPerson2)
        Me.Controls.Add(Me.lblPerson1)
        Me.Controls.Add(Me.lblPerson0)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblPerson0.Text = _
            "Rod Stephens" & vbCrLf & _
            "1234 Programmer Way" & vbCrLf & _
            "Bugsville CO 12345"
        lblPerson1.Text = _
            "Carl Coder" & vbCrLf & _
            "765 Abend Ave" & vbCrLf & _
            "Mainframe AZ 23456"
        lblPerson2.Text = _
            "Denise Developer" & vbCrLf & _
            "38271 Core Dump Blvd" & vbCrLf & _
            "Desktop UT 34567"

        ' Make an array of the Labels.
        Dim labels() As Label = {lblPerson0, lblPerson1, lblPerson2}

        ' Give the Labels the same event handlers.
        For i As Integer = labels.GetLowerBound(0) To labels.GetUpperBound(0)
            AddHandler labels(i).MouseDown, AddressOf label_MouseDown
            'AddHandler m_AnimalLabel(i).DragDrop, AddressOf lblAnimal_DragDrop
        Next i

        AddHandler lstPersonInfo.DragEnter, AddressOf list_DragEnter
        AddHandler lstPersonInfo.DragDrop, AddressOf list_DragDrop
    End Sub

    ' If this is the right mouse button,
    ' start a drag.
    Private Sub label_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        ' Make sure this is the right mouse button.
        If Button.MouseButtons <> MouseButtons.Right Then Exit Sub

        ' Make a Person object containing the data.
        Dim lbl As Label = DirectCast(sender, Label)
        Dim source_person As New Person(lbl.Text)

        ' Start the drag.
        lbl.DoDragDrop(source_person, DragDropEffects.Copy)
    End Sub

    ' See if we want to allow a drop here.
    Private Sub list_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        ' Make sure there is Person data.
        If e.Data.GetDataPresent("howto_net_drag_drop_object.Person") Then
            e.Effect = DragDropEffects.Copy
        Else
            ' There is no Person data.
            e.Effect = DragDropEffects.None
        End If
    End Sub

    ' Finish the drag.
    Private Sub list_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        ' Get the Person data.,
        Dim the_person As Person = DirectCast( _
            e.Data.GetData("howto_net_drag_drop_object.Person"), Person)

        ' Display the person's data.
        lstPersonInfo.Items.Clear()
        lstPersonInfo.Items.Add(the_person.Name)
        lstPersonInfo.Items.Add(the_person.Street)
        lstPersonInfo.Items.Add(the_person.City & " " & the_person.State & " " & the_person.Zip)
    End Sub
End Class
